/// <reference types="node" />
import type * as http from 'http';
import type { Connect } from 'types/connect';
import type { ResolvedServerOptions } from './server';
import type { CommonServerOptions } from './http';
import type { InlineConfig, ResolvedConfig } from '.';
export interface PreviewOptions extends CommonServerOptions {
}
export interface ResolvedPreviewOptions extends PreviewOptions {
}
export declare function resolvePreviewOptions(preview: PreviewOptions | undefined, server: ResolvedServerOptions): ResolvedPreviewOptions;
export interface PreviewServer {
    /**
     * The resolved vite config object
     */
    config: ResolvedConfig;
    /**
     * native Node http server instance
     */
    httpServer: http.Server;
    /**
     * Print server urls
     */
    printUrls: () => void;
}
export declare type PreviewServerHook = (server: {
    middlewares: Connect.Server;
    httpServer: http.Server;
}) => (() => void) | void | Promise<(() => void) | void>;
/**
 * Starts the Vite server in preview mode, to simulate a production deployment
 */
export declare function preview(inlineConfig?: InlineConfig): Promise<PreviewServer>;
